	title	weekday
;11:01 AM 5/11/2006
	if1
        include MACLIB.ASM
; // 10/19/2002 22:17
	endif
weekday	segment
	assume	cs:weekday,ds:weekday
video_int	equ	10h
clock_int	equ	1Ah
keyboard_int	equ	16h
dos_int	equ	21h
mouse_int	equ	33h
byte_si	equ	byte ptr [SI]
	org	100h
_week	proc	near
start_here EQU $
	jmp    begin
_week	endp
PUT	proc	near	; write DL to CRT
	push	dx
put1 EQU $
	push	ax
	mov	ah,2	; display output
	int	dos_int
	puls	ax,dx
	ret
PUT	endp
.SALL
put_comma proc	near
	push	dx
	mov	dl,','
	jmp	put1
put_comma endp	
putspace proc	near
	push	dx
	mov	dl,' '
	call	put
	pop	dx
	ret
putspace endp	
PRINT	proc	near	; PRINT UNTIL ZERO routine
; SI > Ascii Zero String
	push	dx
print_next:
	lodsb
	and	al,al	; is it ZERO
	jz	printexit
	mov	dl,al
	call	put	; print it
	jmp	print_next; loop for more
printexit:
	pop	dx
	ret
PRINT	endp
print_a	proc	near
; PRINT UNTIL ZERO routine
; with attributes
; DI > text ascii-Z string
; BL = attribute
;
; Have to use PUTCRLF routine instead
; of 13,10 in a string because funny
; graphic characters print
	pshs	di,si
	mov	si,di
	pushf	; save direction Flag
	cld	; Set Direction Flag Up
print_a1:
	lodsb
	and	al,al	; is it end ?
	jz	print_a_x
	call	write_char_attribute; print it AL
	jmp	print_a1 ; loop for more
print_a_x:
	popf	; Restore direction Flag
	puls	si,di
	ret
print_a	endp
CX_TH	proc	near	; find cx_th entry in table
; SI > Ascii Zero String Table
; CX is count of Entry to be found
	and	cx,cx
	jz	cx_th_exit
	dec	cx	; is it first entry
	jz	cx_th_exit; is first then exit
cx_th_next:
	lodsb
	and	al,al	; is byte equal zero
	jnz	cx_th_next; search for zero
	loop	cx_th_next; find cx_th zero
cx_th_exit:
	ret	; cx_th zero found exit
CX_TH	endp
	public	cx_th_print
CX_TH_PRINT	proc	near
; SI > Table
; CX is count
	push	cx
	call	cx_th
	call	print
	pop	cx
	ret
CX_TH_PRINT	endp
dec16out	proc	near
; ROUTINE TO CONVERT FROM INTERNAL 16-BIT
; BINARY TO ASCII DECIMAL
; DI >'S TO 10 BYTE BUFFER
; AL IS INITIALIZE CHAR ASCII ZERO OR BLANK
; BX IS MINIMUM # OF DIGITS TO BE PRINTED
; DX is Binary Number
	pshs	di,dx,cx,ax
	mov	cx,10
	push	di
dec16out0:
	mov	[di],al	; clear buffer
	inc	di
	loop	dec16out0
	pop	di	; point to buffer
	push	di
; CX is zero after loop
dec16out1:
	push	cx	; save cx
	mov	ax,dx	; numerator
	sub	dx,dx	; clear upper half
	mov	cx,10	; divisor of 10
	div	cx	; divide
	xchg	ax,dx	; get quotient
;
	add	al,30H	; add ascii 0
	mov	[di],al	; put in buffer
	inc	di
;
	pop	cx	; restore CX for the count
	inc	cx	; count the digit
	cmp	dx,0	; done?
	jnz	dec16out1
;
; dump buffer out
;
	cmp	cx,bx
	jge	dec16out2
	pop	di
	add	di,bx
	mov	cx,bx
	jmp	short dec16out3
dec16out2:
	pop	ax	; balance stack
dec16out3:
	dec	di	; back up through the buffer
	mov	dl,[di]	; get the byte from buffer
	call	put
	loop	dec16out3
;
	puls	ax,cx,dx,di	; restore registers
	ret		; return
dec16out	endp
DUMP_BYTE	proc	near
; Dump BH to Screen
; uses BINIHEX logic
	pshs	ax,cx,dx
	pushf
	mov	cx,0204h
DUMP_BYTE	endp
BINIHEX	proc	near
; Biniary to Hexadecimal
; Dump BH Register
; ch number of digits
; cl number of bits
rotate:
	rol	bx,cl	; left digit to right digit
	mov	al,bl	; move to AL
	and	al,0Fh	; mask off left digit
;From 8080a/8085 assembly language
;programming pg 7-3
; Lance A. Leventhal
; Binary digit to Ascii Digit
; with no jumps
	add	al,90H	; add BCD 90
	daa	; decimal adjust
	adc	al,40H	; add BCD 40 and carry
	daa	; decimal adjust
	mov	dl,al
	mov	ah,2	; Print Hex Digit
	int	dos_int
	dec	ch	; done 4 digits
	jnz	rotate	; yet
	popf
	puls	dx,cx,ax
	ret
BINIHEX endp
clock_print	proc	near
; Routine called DUMP_BYTE
	pshs	ax,bx,dx	
	mov	ah,2
	mov	bh,ch	; Hours
	call	dump_byte
	mov	dl,':'
	int	dos_int
	mov	bh,cl	; Minutes
	call	dump_byte
	int	dos_int
	mov	bh,dh	; Seconds
	call	dump_byte
	puls	dx,bx,ax
	ret
clock_print	endp
PUTCRLF	proc	near
; Print Carriage Return
; and Line Feed on Screen
; Routines called none
	pshs	dx,ax
	mov	ah,2
	mov	dx,0A0Dh
	int	dos_int
	xchg	dh,dl
	int	dos_int
	puls	ax,dx
	ret
PUTCRLF	endp
CURSOR_RIGHT	proc	near
	pshs	ax,bx,cx,dx
	mov	ah,3	; read cursor position
	sub	bh,bh	; on page zero
	int	video_int	; read cursor position
	mov	ah,2	; set new cursor position
	inc	dl	; set column to next position
	cmp	dl,79	; is it end of line ?
	jbe	cursor_right_ok
	call	putcrlf
	jmp	done
cursor_right_ok:
	int	video_int
done:
	puls	dx,cx,bx,ax
	ret
CURSOR_RIGHT	endp
WRITE_CHAR	proc	near
; AL byte to write
	pshs	ax,bx,cx,dx
	mov	bl,07h	; colour white
write_char_with_colour equ $
	mov	ah,9	; call for output of char/attr
	sub	bh,bh	; set to display page zero
	mov	cx,1	; write one char
	int	video_int	; write char and attr
	call	cursor_right	; Now move cursor right
	puls	dx,cx,bx,ax
	ret
WRITE_CHAR	endp
WRITE_CHAR_ATTRIBUTE	proc	near
; AL byte to write
; BL must contain colour attribute 
	pshs	ax,bx,cx,dx
	jmp	write_char_with_colour
WRITE_CHAR_ATTRIBUTE	endp
put_comma_space proc near
	call	put_comma
	call	putspace
	ret
put_comma_space endp
GET	proc	near	; KEYBOARD
; read keyboard into AL
	sub	ah,ah	; input without echo
	int	keyboard_int	; keyboard primitive
	ret		; scan code in AH
GET	endp
main	proc	near
begin equ $
	PUSH	CS
	POP	ds
	mov	bl,15	; White
	mov	si,offset crlf
	call	print
	mov	ah,2Ah	; ask date
	int	dos_int
; DL is day, DH is month
; CX is year
; AL is day of week ( 0 = Sunday
; 1 = Monday)
	cmp	al,6
	jg	exit	; too big
	cmp	dh,12
	jg	exit	; too big
	and	dh,dh
	jz	exit	; too small
	push	cx
	sub	cx,cx
	inc	al
	mov	cl,al
	mov	si,offset days
	call	cx_th_print; Day
        call	put_comma_space
	mov	si,offset month
	mov	cl,dh
	call	cx_th_print; Month
	call	putspace
	sub	dh,dh
	mov	bh,dl; dl has day of month
	mov	di,offset tbuff
	mov	al,20h
	mov	bx,2
	call	dec16out
        call	put_comma_space
  	mov	di,offset tbuff; buffer
	mov	al,20h	; edit fill char
	mov	bx,4	; edit length
	pop	dx	; want year in DX
	call	dec16out
	call	putspace
	mov	ah,2	; read clock
	int	clock_int; dos function
; CH hours CL min DH seconds
	call	clock_print
	call	putspace
	mov	si,offset daytime
	mov	byte_si,'A'
	cmp	ch,12h
	jc	morning
	mov	byte_si,'P'
morning:
	call	print
	call	get
exit:
	call	putcrlf
	mov	ah,4Ch
	int	dos_int
main	endp
daytime	equ	$
	db	' M',0
tbuff	db 10 dup ('0')
crlf	equ	$
	db	13,10,0
month	equ	$
	AZ	'January'
	AZ	'February'
	AZ	'March'
	AZ	'April'
	AZ	'May'
	AZ	'June'
	AZ	'July'
	AZ	'August'
	AZ	'September'
	AZ	'October'
	AZ	'November'
	AZ	'December'
days	equ	$
	AZ	'Sunday'
	AZ	'Monday'
	AZ	'Tuesday'
	AZ	'Wednesday'
	AZ	'Thursday'
	AZ	'Friday'
	AZ	'Saturday'
weekday	ends
	end	_week

